diff --git a/sys/dev/netif/ig_hal/e1000_82542.c b/sys/dev/netif/ig_hal/e1000_82542.c
index cf20d88fa1..4cca9b2b2c 100644
--- a/sys/dev/netif/ig_hal/e1000_82542.c
+++ b/sys/dev/netif/ig_hal/e1000_82542.c
@@ -1,6 +1,6 @@
 /******************************************************************************
 
-  Copyright (c) 2001-2014, Intel Corporation 
+  Copyright (c) 2001-2015, Intel Corporation 
   All rights reserved.
   
   Redistribution and use in source and binary forms, with or without 
@@ -30,7 +30,7 @@
   POSSIBILITY OF SUCH DAMAGE.
 
 ******************************************************************************/
-/*$FreeBSD:$*/
+/*$FreeBSD$*/
 
 /*
  * 82542 Gigabit Ethernet Controller
diff --git a/sys/dev/netif/ig_hal/e1000_82543.c b/sys/dev/netif/ig_hal/e1000_82543.c
index 4d29f3dda0..279e41e8b4 100644
--- a/sys/dev/netif/ig_hal/e1000_82543.c
+++ b/sys/dev/netif/ig_hal/e1000_82543.c
@@ -1,6 +1,6 @@
 /******************************************************************************
 
-  Copyright (c) 2001-2014, Intel Corporation 
+  Copyright (c) 2001-2015, Intel Corporation 
   All rights reserved.
   
   Redistribution and use in source and binary forms, with or without 
@@ -30,7 +30,7 @@
   POSSIBILITY OF SUCH DAMAGE.
 
 ******************************************************************************/
-/*$FreeBSD:$*/
+/*$FreeBSD$*/
 
 /*
  * 82543GC Gigabit Ethernet Controller (Fiber)
diff --git a/sys/dev/netif/ig_hal/e1000_82543.h b/sys/dev/netif/ig_hal/e1000_82543.h
index b7b90789ed..e8edda5d2b 100644
--- a/sys/dev/netif/ig_hal/e1000_82543.h
+++ b/sys/dev/netif/ig_hal/e1000_82543.h
@@ -1,6 +1,6 @@
 /******************************************************************************
 
-  Copyright (c) 2001-2014, Intel Corporation 
+  Copyright (c) 2001-2015, Intel Corporation 
   All rights reserved.
   
   Redistribution and use in source and binary forms, with or without 
@@ -30,7 +30,7 @@
   POSSIBILITY OF SUCH DAMAGE.
 
 ******************************************************************************/
-/*$FreeBSD:$*/
+/*$FreeBSD$*/
 
 #ifndef _E1000_82543_H_
 #define _E1000_82543_H_
diff --git a/sys/dev/netif/ig_hal/e1000_82571.c b/sys/dev/netif/ig_hal/e1000_82571.c
index c362c8cdeb..ec855c236f 100644
--- a/sys/dev/netif/ig_hal/e1000_82571.c
+++ b/sys/dev/netif/ig_hal/e1000_82571.c
@@ -1,6 +1,6 @@
 /******************************************************************************
 
-  Copyright (c) 2001-2014, Intel Corporation 
+  Copyright (c) 2001-2015, Intel Corporation 
   All rights reserved.
   
   Redistribution and use in source and binary forms, with or without 
@@ -30,7 +30,7 @@
   POSSIBILITY OF SUCH DAMAGE.
 
 ******************************************************************************/
-/*$FreeBSD:$*/
+/*$FreeBSD$*/
 
 /* 82571EB Gigabit Ethernet Controller
  * 82571EB Gigabit Ethernet Controller (Copper)
diff --git a/sys/dev/netif/ig_hal/e1000_82571.h b/sys/dev/netif/ig_hal/e1000_82571.h
index 8c48b02895..8e5ca56ae8 100644
--- a/sys/dev/netif/ig_hal/e1000_82571.h
+++ b/sys/dev/netif/ig_hal/e1000_82571.h
@@ -1,6 +1,6 @@
 /******************************************************************************
 
-  Copyright (c) 2001-2014, Intel Corporation 
+  Copyright (c) 2001-2015, Intel Corporation 
   All rights reserved.
   
   Redistribution and use in source and binary forms, with or without 
@@ -30,7 +30,7 @@
   POSSIBILITY OF SUCH DAMAGE.
 
 ******************************************************************************/
-/*$FreeBSD:$*/
+/*$FreeBSD$*/
 
 #ifndef _E1000_82571_H_
 #define _E1000_82571_H_
diff --git a/sys/dev/netif/ig_hal/e1000_api.c b/sys/dev/netif/ig_hal/e1000_api.c
index 254691da99..492ef5ec67 100644
--- a/sys/dev/netif/ig_hal/e1000_api.c
+++ b/sys/dev/netif/ig_hal/e1000_api.c
@@ -1,6 +1,6 @@
 /******************************************************************************
 
-  Copyright (c) 2001-2014, Intel Corporation 
+  Copyright (c) 2001-2015, Intel Corporation 
   All rights reserved.
   
   Redistribution and use in source and binary forms, with or without 
@@ -30,7 +30,7 @@
   POSSIBILITY OF SUCH DAMAGE.
 
 ******************************************************************************/
-/*$FreeBSD:$*/
+/*$FreeBSD$*/
 
 #include "e1000_api.h"
 
@@ -155,11 +155,9 @@ s32 e1000_set_mac_type(struct e1000_hw *hw)
 	DEBUGFUNC("e1000_set_mac_type");
 
 	switch (hw->device_id) {
-#ifndef NO_82542_SUPPORT
 	case E1000_DEV_ID_82542:
 		mac->type = e1000_82542;
 		break;
-#endif
 	case E1000_DEV_ID_82543GC_FIBER:
 	case E1000_DEV_ID_82543GC_COPPER:
 		mac->type = e1000_82543;
@@ -301,12 +299,12 @@ s32 e1000_set_mac_type(struct e1000_hw *hw)
 	case E1000_DEV_ID_PCH_I218_LM3:
 	case E1000_DEV_ID_PCH_I218_V3:
 		mac->type = e1000_pch_lpt;
- 		break;
+		break;
 	case E1000_DEV_ID_PCH_SPT_I219_LM:
 	case E1000_DEV_ID_PCH_SPT_I219_V:
 	case E1000_DEV_ID_PCH_SPT_I219_LM2:
 	case E1000_DEV_ID_PCH_SPT_I219_V2:
-	case E1000_DEV_ID_PCH_SPT_I219_LM3:
+	case E1000_DEV_ID_PCH_LBG_I219_LM3:
 	case E1000_DEV_ID_PCH_SPT_I219_LM4:
 	case E1000_DEV_ID_PCH_SPT_I219_V4:
 	case E1000_DEV_ID_PCH_SPT_I219_LM5:
@@ -427,11 +425,9 @@ s32 e1000_setup_init_funcs(struct e1000_hw *hw, bool init_device)
 	 * the functions in that family.
 	 */
 	switch (hw->mac.type) {
-#ifndef NO_82542_SUPPORT
 	case e1000_82542:
 		e1000_init_function_pointers_82542(hw);
 		break;
-#endif
 	case e1000_82543:
 	case e1000_82544:
 		e1000_init_function_pointers_82543(hw);
diff --git a/sys/dev/netif/ig_hal/e1000_api.h b/sys/dev/netif/ig_hal/e1000_api.h
index e8d64103f3..86075f8e61 100644
--- a/sys/dev/netif/ig_hal/e1000_api.h
+++ b/sys/dev/netif/ig_hal/e1000_api.h
@@ -1,6 +1,6 @@
 /******************************************************************************
 
-  Copyright (c) 2001-2014, Intel Corporation 
+  Copyright (c) 2001-2015, Intel Corporation 
   All rights reserved.
   
   Redistribution and use in source and binary forms, with or without 
@@ -30,16 +30,14 @@
   POSSIBILITY OF SUCH DAMAGE.
 
 ******************************************************************************/
-/*$FreeBSD:$*/
+/*$FreeBSD$*/
 
 #ifndef _E1000_API_H_
 #define _E1000_API_H_
 
 #include "e1000_hw.h"
 
-#ifndef NO_82542_SUPPORT
 extern void e1000_init_function_pointers_82542(struct e1000_hw *hw);
-#endif
 extern void e1000_init_function_pointers_82543(struct e1000_hw *hw);
 extern void e1000_init_function_pointers_82540(struct e1000_hw *hw);
 extern void e1000_init_function_pointers_82571(struct e1000_hw *hw);
@@ -119,9 +117,7 @@ s32 e1000_mng_host_if_write(struct e1000_hw *hw, u8 *buffer, u16 length,
 s32 e1000_mng_write_cmd_header(struct e1000_hw *hw,
 			       struct e1000_host_mng_command_header *hdr);
 s32 e1000_mng_write_dhcp_info(struct e1000_hw *hw, u8 *buffer, u16 length);
-#ifndef NO_82542_SUPPORT
 u32  e1000_translate_register_82542(u32 reg);
-#endif
 
 
 
diff --git a/sys/dev/netif/ig_hal/e1000_defines.h b/sys/dev/netif/ig_hal/e1000_defines.h
index aa82e39fad..78321ee4cb 100644
--- a/sys/dev/netif/ig_hal/e1000_defines.h
+++ b/sys/dev/netif/ig_hal/e1000_defines.h
@@ -1,6 +1,6 @@
 /******************************************************************************
 
-  Copyright (c) 2001-2014, Intel Corporation 
+  Copyright (c) 2001-2015, Intel Corporation 
   All rights reserved.
   
   Redistribution and use in source and binary forms, with or without 
@@ -30,7 +30,7 @@
   POSSIBILITY OF SUCH DAMAGE.
 
 ******************************************************************************/
-/*$FreeBSD:$*/
+/*$FreeBSD$*/
 
 #ifndef _E1000_DEFINES_H_
 #define _E1000_DEFINES_H_
@@ -727,9 +727,7 @@
 #define E1000_COLD_SHIFT		12
 
 /* Default values for the transmit IPG register */
-#ifndef NO_82542_SUPPORT
 #define DEFAULT_82542_TIPG_IPGT		10
-#endif
 #define DEFAULT_82543_TIPG_IPGT_FIBER	9
 #define DEFAULT_82543_TIPG_IPGT_COPPER	8
 
@@ -737,15 +735,11 @@
 #define E1000_TIPG_IPGR1_MASK		0x000FFC00
 #define E1000_TIPG_IPGR2_MASK		0x3FF00000
 
-#ifndef NO_82542_SUPPORT
 #define DEFAULT_82542_TIPG_IPGR1	2
-#endif
 #define DEFAULT_82543_TIPG_IPGR1	8
 #define E1000_TIPG_IPGR1_SHIFT		10
 
-#ifndef NO_82542_SUPPORT
 #define DEFAULT_82542_TIPG_IPGR2	10
-#endif
 #define DEFAULT_82543_TIPG_IPGR2	6
 #define DEFAULT_80003ES2LAN_TIPG_IPGR2	7
 #define E1000_TIPG_IPGR2_SHIFT		20
@@ -755,6 +749,8 @@
 
 #define ETHERNET_FCS_SIZE		4
 #define MAX_JUMBO_FRAME_SIZE		0x3F00
+/* The datasheet maximum supported RX size is 9.5KB (9728 bytes) */
+#define MAX_RX_JUMBO_FRAME_SIZE		0x2600
 #define E1000_TX_PTR_GAP		0x1F
 
 /* Extended Configuration Control and Size */
@@ -1142,6 +1138,12 @@
 #define E1000_TSYNCTXCTL_VALID		0x00000001 /* Tx timestamp valid */
 #define E1000_TSYNCTXCTL_ENABLED	0x00000010 /* enable Tx timestamping */
 
+/* HH Time Sync */
+#define E1000_TSYNCTXCTL_MAX_ALLOWED_DLY_MASK	0x0000F000 /* max delay */
+#define E1000_TSYNCTXCTL_SYNC_COMP_ERR		0x20000000 /* sync err */
+#define E1000_TSYNCTXCTL_SYNC_COMP		0x40000000 /* sync complete */
+#define E1000_TSYNCTXCTL_START_SYNC		0x80000000 /* initiate sync */
+
 #define E1000_TSYNCRXCTL_VALID		0x00000001 /* Rx timestamp valid */
 #define E1000_TSYNCRXCTL_TYPE_MASK	0x0000000E /* Rx type mask */
 #define E1000_TSYNCRXCTL_TYPE_L2_V2	0x00
diff --git a/sys/dev/netif/ig_hal/e1000_hw.h b/sys/dev/netif/ig_hal/e1000_hw.h
index 9c19d05b48..e383e56368 100644
--- a/sys/dev/netif/ig_hal/e1000_hw.h
+++ b/sys/dev/netif/ig_hal/e1000_hw.h
@@ -1,6 +1,6 @@
 /******************************************************************************
 
-  Copyright (c) 2001-2014, Intel Corporation 
+  Copyright (c) 2001-2015, Intel Corporation 
   All rights reserved.
   
   Redistribution and use in source and binary forms, with or without 
@@ -30,7 +30,7 @@
   POSSIBILITY OF SUCH DAMAGE.
 
 ******************************************************************************/
-/*$FreeBSD:$*/
+/*$FreeBSD$*/
 
 #ifndef _E1000_HW_H_
 #define _E1000_HW_H_
@@ -41,9 +41,7 @@
 
 struct e1000_hw;
 
-#ifndef NO_82542_SUPPORT
 #define E1000_DEV_ID_82542			0x1000
-#endif
 #define E1000_DEV_ID_82543GC_FIBER		0x1001
 #define E1000_DEV_ID_82543GC_COPPER		0x1004
 #define E1000_DEV_ID_82544EI_COPPER		0x1008
@@ -126,27 +124,25 @@ struct e1000_hw;
 #define E1000_DEV_ID_ICH10_D_BM_LM		0x10DE
 #define E1000_DEV_ID_ICH10_D_BM_LF		0x10DF
 #define E1000_DEV_ID_ICH10_D_BM_V		0x1525
-
 #define E1000_DEV_ID_PCH_M_HV_LM		0x10EA
 #define E1000_DEV_ID_PCH_M_HV_LC		0x10EB
 #define E1000_DEV_ID_PCH_D_HV_DM		0x10EF
 #define E1000_DEV_ID_PCH_D_HV_DC		0x10F0
 #define E1000_DEV_ID_PCH2_LV_LM			0x1502
 #define E1000_DEV_ID_PCH2_LV_V			0x1503
-
 #define E1000_DEV_ID_PCH_LPT_I217_LM		0x153A
 #define E1000_DEV_ID_PCH_LPT_I217_V		0x153B
 #define E1000_DEV_ID_PCH_LPTLP_I218_LM		0x155A
 #define E1000_DEV_ID_PCH_LPTLP_I218_V		0x1559
 #define E1000_DEV_ID_PCH_I218_LM2		0x15A0
 #define E1000_DEV_ID_PCH_I218_V2		0x15A1
-#define E1000_DEV_ID_PCH_I218_LM3		0x15A2	/* Wildcat Point PCH */
-#define E1000_DEV_ID_PCH_I218_V3		0x15A3	/* Wildcat Point PCH */
-#define E1000_DEV_ID_PCH_SPT_I219_LM		0x156F	/* SPT */
-#define E1000_DEV_ID_PCH_SPT_I219_V		0x1570
-#define E1000_DEV_ID_PCH_SPT_I219_LM2		0x15B7
-#define E1000_DEV_ID_PCH_SPT_I219_V2		0x15B8
-#define E1000_DEV_ID_PCH_SPT_I219_LM3		0x15B9	/* LEWISBURG PCH */
+#define E1000_DEV_ID_PCH_I218_LM3		0x15A2 /* Wildcat Point PCH */
+#define E1000_DEV_ID_PCH_I218_V3		0x15A3 /* Wildcat Point PCH */
+#define E1000_DEV_ID_PCH_SPT_I219_LM		0x156F /* Sunrise Point PCH */
+#define E1000_DEV_ID_PCH_SPT_I219_V		0x1570 /* Sunrise Point PCH */
+#define E1000_DEV_ID_PCH_SPT_I219_LM2		0x15B7 /* Sunrise Point-H PCH */
+#define E1000_DEV_ID_PCH_SPT_I219_V2		0x15B8 /* Sunrise Point-H PCH */
+#define E1000_DEV_ID_PCH_LBG_I219_LM3		0x15B9 /* LEWISBURG PCH */
 #define E1000_DEV_ID_PCH_SPT_I219_LM4		0x15D7
 #define E1000_DEV_ID_PCH_SPT_I219_V4		0x15D8
 #define E1000_DEV_ID_PCH_SPT_I219_LM5		0x15E3
@@ -213,9 +209,7 @@ struct e1000_hw;
 
 enum e1000_mac_type {
 	e1000_undefined = 0,
-#ifndef NO_82542_SUPPORT
 	e1000_82542,
-#endif
 	e1000_82543,
 	e1000_82544,
 	e1000_82540,
@@ -819,9 +813,7 @@ struct e1000_mac_info {
 	bool autoneg_failed;
 	bool get_link_status;
 	bool in_ifs_mode;
-#ifndef NO_82542_SUPPORT
 	bool report_tx_early;
-#endif
 	enum e1000_serdes_link_state serdes_link_state;
 	bool serdes_has_link;
 	bool tx_pkt_filtering;
@@ -903,12 +895,10 @@ struct e1000_dev_spec_82541 {
 	bool phy_init_script;
 };
 
-#ifndef NO_82542_SUPPORT
 struct e1000_dev_spec_82542 {
 	bool dma_fairness;
 };
 
-#endif /* NO_82542_SUPPORT */
 struct e1000_dev_spec_82543 {
 	u32  tbi_compatibility;
 	bool dma_fairness;
@@ -969,7 +959,7 @@ struct e1000_dev_spec_82575 {
 	bool media_changed;
 };
 
-#define E1000_SHADOW_RAM_WORDS  2048
+#define E1000_SHADOW_RAM_WORDS		2048
 
 /* I218 PHY Ultra Low Power (ULP) states */
 enum e1000_ulp_state {
@@ -1009,9 +999,7 @@ struct e1000_hw {
 
 	union {
 		struct e1000_dev_spec_82541 _82541;
-#ifndef NO_82542_SUPPORT
 		struct e1000_dev_spec_82542 _82542;
-#endif
 		struct e1000_dev_spec_82543 _82543;
 		struct e1000_dev_spec_82571 _82571;
 		struct e1000_dev_spec_80003es2lan _80003es2lan;
@@ -1037,10 +1025,8 @@ struct e1000_hw {
 #include "e1000_i210.h"
 
 /* These functions must be implemented by drivers */
-#ifndef NO_82542_SUPPORT
 void e1000_pci_clear_mwi(struct e1000_hw *hw);
 void e1000_pci_set_mwi(struct e1000_hw *hw);
-#endif
 s32  e1000_read_pcie_cap_reg(struct e1000_hw *hw, u32 reg, u16 *value);
 s32  e1000_write_pcie_cap_reg(struct e1000_hw *hw, u32 reg, u16 *value);
 void e1000_read_pci_cfg(struct e1000_hw *hw, u32 reg, u16 *value);
